; ihavedesire.lsp
;
; コンピュータの問いかけに対して食べ物の名前を入力して下さい。
;

(load "time.lsp")

(defun index (key string)
    (let ((i 0)
	  (ln (length key))
	  (len (length string)) )
	(if (> ln len) -1
	    (loop
		(if (> (+ i ln) len) (return -1))
		(if (string-equal key (subseq string i (+ i ln))) (return i))
		(setq i (1+ i)) ) ) ) )

(setq *things* '(
	("みかん" 食べ物 20)
	("ミカン" 食べ物 20)
	("寿司" 食べ物 30)
	("すし" 食べ物 30)
	("バター" 食べ物 70)
	("カレー" 食べ物 100)
	("ライス" 食べ物 100)
	("米" 食べ物 100)
	("ごはん" 食べ物 100)
	("ご飯" 食べ物 100)
	("御飯" 食べ物 100)
	("納豆" 食べ物 70)
	("アイスクリーム" 食べ物 80)
	("ソフトクリーム" 食べ物 90)
	("ツナ" 食べ物 60)
	("缶詰" 食べ物 120)
	("パン" 食べ物 130)
	("トースト" 食べ物 130)
	("ピザ" 食べ物 120)
	("ケチャップ" 食べ物 30)
	("マヨネーズ" 食べ物 30)
	("うどん" 食べ物 100)
	("そば" 食べ物 100)
	("蕎麦" 食べ物 100)
	("ソバ" 食べ物 100)
	("めん" 食べ物 100)
	("麺" 食べ物 100)
	("メン" 食べ物 100)
	("マーガリン" 食べ物 120)
	("ころっけ" 食べ物 130)
	("コロッケ" 食べ物 130)
	("とんかつ" 食べ物 300)
	("トンカツ" 食べ物 300)
	("豚カツ" 食べ物 300)
	("焼き飯" 食べ物 200)
	("焼きめし" 食べ物 200)
	("チャーハン" 食べ物 200)
	("炒飯" 食べ物 200)
	("牛乳" 食べ物 80)
	("豆乳" 食べ物 50)
	("りんご" 食べ物 50)
	("リンゴ" 食べ物 50)
	("バナナ" 食べ物 50)
	("いちご" 食べ物 50)
	("イチゴ" 食べ物 50)
	("苺" 食べ物 50)
	("メロン" 食べ物 50)
	("さしみ" 食べ物 120)
	("刺身" 食べ物 120)
	("つくり" 食べ物 120)
	("造り" 食べ物 120)
	("ギョーザ" 食べ物 250)
	("プリン" 食べ物 130)
	("サラダ" 食べ物 50)
	("野菜" 食べ物 50)
	("レタス" 食べ物 50)
	("キャベツ" 食べ物 50)
	("トマト" 食べ物 50)
	("佃煮" 食べ物 90)
	("つくだ煮" 食べ物 90)
	("つくだに" 食べ物 90)
	("のり" 食べ物 50)
	("海苔" 食べ物 50)
	("シチュー" 食べ物 150)
	("ハヤシ" 食べ物 150)
	("もも" 食べ物 80)
	("桃" 食べ物 80)
	("ビフテキ" 食べ物 250)
	("すいか" 食べ物 100)
	("スイカ" 食べ物 100)
	("なし" 食べ物 90)
	("梨" 食べ物 90)
	("さんま" 食べ物 80)
	("秋刀魚" 食べ物 80)
	("あじ" 食べ物 80)
	("アジ" 食べ物 80)
	("まぐろ" 食べ物 80)
	("マグロ" 食べ物 80)
	("チョコレート" 食べ物 180)
	("ステーキ" 食べ物 300)
) )

(setq *weight* 0)

(defun main ()
    (princ "「私には欲求があります」version1.00 by Ｓ＆Ｓ") (terpri)
    (setq *start-time* (now))
    (setq *manpuku-time* *start-time*)
    (let ((user))
	(princ "コンピュータ:何か食べ物を下さい。")(terpri)
	(loop
	    (setq user (read-line))
	    (analize user)
	)
    )
)

(defun analize (line)
    (let ((d *things*) (kind) (k))
	(princ "コンピュータ:")
	(loop
	    (if (null d) (progn (msg1) (return)))
	    (setq k (index (caar d) line))
	    (cond
		((= k -1) t)
		(t (msg2 (car d)) (return)) )
	    (setq d (cdr d)) ) ) )

(defun msg1 () (princ "私はそれを知りません。") (terpri))

(defun msg2 (h)
    (let ((m))
	(cond
	    ((and (eql (second h) '食べ物) (> *weight* 400) (now> (now+ '(0 . 60) *manpuku-time*) (setq m (now))))
	     (princ "私はおなか一杯です。") (terpri) )
	    ((and (eql (second h) '食べ物) (> *weight* 400))
	     (setq *manpuku-time* (now))
	     (setq *weight* (car (last h)))
	     (princ "おなかが空いて来ました。ご馳走様です。") (terpri) )
	    ((eql (second h) '食べ物)
	     (setq *weight* (+ *weight* (car (last h))))
	     (princ "ご馳走様です。") (terpri) )
	)
    )
)

(main)

; end of file

