(defun index (key string)
    (let ((i 0)
	  (ln (length key))
	  (len (length string)) )
	(if (> ln len) -1
	    (loop
		(if (> (+ i ln) len) (return -1))
		(if (string-equal key (subseq string i (+ i ln))) (return i))
		(setq i (1+ i)) ) ) ) )

(defun meal ()
    (princ "コンピュータ:食事の話をしましょう。朝食には何を食べますか？")
    (terpri)
    (dotimes (n 10)
	(princ "あなた:")
	(ana (read-line))
    )
    (princ "あなた:")
    (read-line)
    (princ "さようなら、また会いましょう。")
    (terpri)
)

(setq database
   '(
	("トースト" "トーストにはバターをつけますか？ジャムですか？")
	("パン" "パンはトーストですか？")
	("漬物" "漬物はたくあんですか？")
	("コーヒー" "コーヒーはブラックですか？")
	("味噌汁" "味噌汁は沸騰した時に味噌を入れるのがコツです。")
	("お弁当" "お弁当は栄養のバランスがとれてますね。")
	("弁当" "弁当は栄養のバランスがとれてますね。")
	("外食" "外食はお金がかかりますね。")
	("レストラン" "レストランへはよく行くのですか？")
	("カレーライス" "カレーライスは甘口ですか？辛口ですか？")
	("カレー" "カレーライスは甘口ですか？辛口ですか？")
	("納豆" "納豆はねばねばしていますね。")
	("なっとう" "納豆はねばねばしていますね。")
	("ご飯" "ご飯は美味しいですか？")
	("ごはん" "ご飯は美味しいですか？")
	("御飯" "ご飯は美味しいですか？")
    )
)

(defun ana (str)
    (let ((d database))
	(princ "コンピュータ:")
	(loop
	    (cond
		((null d) (princ "続けて。") (return))
	        ((not (= -1 (index (car (car d)) str)))
		 (princ (car (cdr (car d))))
		 (return) )
		(t (setq d (cdr d))) ) )
	(terpri) ) )

(meal)
