; 8queen

(defun nqueen (n) (nqueen2 n nil))

(defun nqueen2 (n acc)
    (cond
	((= n (length acc))
	 (list acc) )
	(t
	 (let ((i 0) (r nil))
	    (loop
		(if (= i n) (return r))
		(if (or (member i acc) (not (check-position n (append acc (list i)))))
		    nil
		    (setq r (append r (nqueen2 n (append acc (list i))))))
		(setq i (1+ i)) ) ) ) ) )

(defun check-position (n acc)
    (if (check-position3d n acc) (check-position2 n acc) nil) )

(defun check-position2 (n acc)
    (if (check-position3 n acc) t nil) )

(defun check-position3 (n acc)
    (cond
	((null acc) t)
	((check-position4 n acc)
	 (check-position3 n (cdr acc)) ) ) )

(defun check-position4 (n acc)
    (let ((a acc) (c))
	(setq c (car a))
	(setq a (cdr a))
	(loop
	    (if (= c (1- n)) (return t))
	    (if (null a) (return t))
	    (setq c (1+ c))
	    (if (= c (car a)) (return nil))
	    (setq a (cdr a)) ) ) )

(defun check-position3d (n acc)
    (cond
	((null acc) t)
	((check-position4d n acc)
	 (check-position3d n (cdr acc)) ) ) )

(defun check-position4d (n acc)
    (let ((a acc) (c))
	(setq c (car a))
	(setq a (cdr a))
	(loop
	    (if (= c 0) (return t))
	    (if (null a) (return t))
	    (setq c (1- c))
	    (if (= c (car a)) (return nil))
	    (setq a (cdr a)) ) ) )

(print (length (print (nqueen 8))))

