; prime.lsp
; 素数を求めます。

(defun prime (n)
    (let ((k 3) (v '(2 3)))
        (loop
	    (setq k (+ k 2))
	    (if (>= k n) (return v))
	    (cond
	        ((rem1 k v) (setq v (append v (list k)))) ) ) ) )

(defun rem1 (k v)
    (loop
	(if (null v) (return t))
	(if (= (remainder k (car v)) 0) (return nil))
	(setq v (cdr v)) ) )

(defun remainder (u k)
    (cond
        ((< u k) u)
	(t (remainder (- u k) k)) ) )

(print (prime 7000))
