; オセロゲーム(jcpplisp)
; (othello) でスタート

(defun othello ()
  (let ((flag1) (flag2) (flag3) )
    (terpri)
    (print (quote オセロゲーム))
    (print (quote Ｃｏｐｙｒｉｇｈｔ（Ｃ）Ｓ＆Ｓ　２０１４))
    (terpri)
    (init-game)
    (setq flag1 NIL)
    (setq flag2 NIL)
    (princ (quote "あなたは先攻で白です。"))
    (terpri)
    (display)
    (loop
        (cond
            ((CanYouGoAll) (setq flag1 NIL) (setq flag3 (you)))
            (T (setq flag1 T)) )
        (if (and flag1 flag2) (return (progn (ending) T)))
        (if (null flag3) (return NIL))
        (cond
            ((computer) (setq flag2 NIL))
            (T (setq flag2 T)) )
        (if (and flag1 flag2) (return (progn (ending) T))) ) ) )

(defun ending ()
  (let ((tate) (yoko) (wct) (bct) (v) )
    (setq wct 0)
    (setq bct 0)
    (setq tate 1)
    (loop
        (if (eq tate 9) (return (progn (msg wct bct) T)))
        (setq yoko 1)
        (loop
            (if (eq yoko 9) (return T))
            (cond
                ((eq (setq v (getBan tate yoko)) (quote W)) (setq wct (+ wct 1)))
                ((eq v (quote B)) (setq bct (+ bct 1)))
                (T NIL) )
            (setq yoko (+ yoko 1)) )
        (setq tate (+ tate 1)) ) ) )

(defun msg (wct bct)
    (cond
        ((> wct bct) (princ wct) (princ (quote "対")) (princ bct) (princ (quote "であなたの勝ちです。")))
        ((< wct bct) (princ bct) (princ (quote "対")) (princ wct) (princ (quote "でコンピュータの勝ちです。")))
        (T (princ wct) (princ (quote "対")) (princ bct) (princ (quote "で引き分けです。"))) ) )

(defun CanYouGoAll ()
  (let ((tate) (yoko) )
    (setq tate 1)
    (loop
        (if (eq tate 9) (return NIL))
        (setq yoko 1)
        (if (loop
             (if (eq yoko 9) (return NIL))
             (if (CanYouGo tate yoko) (return T))
             (setq yoko (+ yoko 1)) ) (return T))
        (setq tate (+ tate 1)) ) ) )

(defun getBan (tate yoko)
    (nth (- yoko 1) (nth (- tate 1) ban)) )

;(defun nth (n s
;    )
;    (cond
;        ((not (integerp n)) (print (quote 数値ではありません)) NIL)
;        ((< n 0) (print (quote 負の数値です)) NIL)
;        (T
;         (loop
;             ((atom s) NIL)
;             ((eq n 0) (car s))
;             (set (quote s) (cdr s))
;             (set (quote n) (- n 1)) ) ) ) )

(defun you ()
  (let ((tate) (yoko) )
    (cond
        ((null
          (loop
            (princ (quote "縦の番号を入力して下さい："))
            (setq tate (read))
            (if (eq (quote bye) tate) (return NIL))
            (princ (quote "横の番号を入力して下さい："))
            (setq yoko (read))
            (if (CanYouGo tate yoko) (return T)) ) ) NIL)
        (T (YouGo tate yoko) (display) T) ) ) )

(defun CanYouGo (tate yoko)
    (cond
        ((not (eq (quote E) (getBan tate yoko))) NIL)
        ((not (zerop (youNN tate yoko))) T)
        ((not (zerop (youNE tate yoko))) T)
        ((not (zerop (youNW tate yoko))) T)
        ((not (zerop (youSE tate yoko))) T)
        ((not (zerop (youSW tate yoko))) T)
        ((not (zerop (youSS tate yoko))) T)
        ((not (zerop (youEE tate yoko))) T)
        ((not (zerop (youWW tate yoko))) T)
        (T NIL) ) )

(defun setBan (tate yoko v)
  (let ((b) (new) (tc) (gyo) )
    (setq new NIL)
    (setq b ban)
    (setq tc 1)
    (loop
        (if (null b) (return (setq ban new)))
        (setq gyo (car b))
        (cond
            ((eq tate tc) (setq gyo (setBan2 gyo yoko v)))
            (T T) )
        (setq tc (+ tc 1))
        (setq b (cdr b))
        (setq new (append new (list gyo))) ) ) )

(defun setBan2 (gyo yoko v)
  (let ((new) (yc) (u) )
    (setq new NIL)
    (setq yc 1)
    (loop
        (if (null gyo) (return new))
        (setq u (car gyo))
        (cond
            ((eq yc yoko) (setq u v))
            (T T) )
        (setq yc (+ yc 1))
        (setq gyo (cdr gyo))
        (setq new (append new (list u))) ) ) )

(defun computer ()
  (let ((koho) (ba) )
    (cond
        ((null (setq koho (makeComputerKoho))) NIL)
        (T
            (princ (quote "コンピュータの番です。"))
	    (terpri)
            (setq ba (bestAnswer koho))
            (ComputerGo (car ba) (car (cdr ba)))
            (display) T ) ) ) )

;(defun bestAnswer (koho
;    k )
;    (cond
;        ((not (null (set (quote k) (answer1 koho)))) (car (car k)))
;        (T (car (car koho))) ) )

(defun bestAnswer (koho)
  (let ((k) (a) )
    (cond
        ((null (setq a (AvoidDead koho))) (car (car koho)))
        ((not (null (setq k (answer1 a)))) (car (car k)))
        (T (car (car a))) ) ) )

(defun AvoidDead (koho)
  (let ((new) (a) )
    (setq new NIL)
    (loop
        (if (null koho) (return new))
        (setq a (car koho))
        (cond
            ((equal (car a) (quote (1 2))) NIL)
            ((equal (car a) (quote (1 7))) NIL)
            ((equal (car a) (quote (2 1))) NIL)
            ((equal (car a) (quote (2 2))) NIL)
            ((equal (car a) (quote (2 7))) NIL)
            ((equal (car a) (quote (2 8))) NIL)
            ((equal (car a) (quote (7 1))) NIL)
            ((equal (car a) (quote (7 2))) NIL)
            ((equal (car a) (quote (7 7))) NIL)
            ((equal (car a) (quote (7 8))) NIL)
            ((equal (car a) (quote (8 2))) NIL)
            ((equal (car a) (quote (8 7))) NIL)
            (T (setq new (append new (list a)))) )
        (setq koho (cdr koho)) ) ) )

(defun answer1 (koho)
    (let ((new) (one) )
    (setq new NIL)
    (loop
        (if (null koho) (return new))
        (setq one (car koho))
        (cond
            ((eq (car (cdr one)) 1) (setq new (append new (list one))))
            (T NIL) )
        (setq koho (cdr koho)) ) ) )

(defun ComputerGo (tate yoko)
  (let ((tt) (yk) )
    (setBan tate yoko (quote B))
    (setq tt tate)
    (setq yk yoko)
    (cond
        ((not (zerop (computerNN tate yoko)))
         (loop
             (setq tate (- tate 1))
             (if (eq (getBan tate yoko) (quote B)) (return T))
             (setBan tate yoko (quote B)) ) ) )
    (setq tate tt)
    (setq yoko yk)
    (cond
        ((not (zerop (computerSS tate yoko)))
         (loop
             (setq tate (+ tate 1))
             (if (eq (getBan tate yoko) (quote B)) (return T))
             (setBan tate yoko (quote B)) ) ) )
    (setq tate tt)
    (setq yoko yk)
    (cond
        ((not (zerop (computerEE tate yoko)))
         (loop
             (setq yoko (+ yoko 1))
             (if (eq (getBan tate yoko) (quote B)) (return T))
             (setBan tate yoko (quote B)) ) ) )
    (setq tate tt)
    (setq yoko yk)
    (cond
        ((not (zerop (computerWW tate yoko)))
         (loop
             (setq yoko (- yoko 1))
             (if (eq (getBan tate yoko) (quote B)) (return T))
             (setBan tate yoko (quote B)) ) ) )
    (setq tate tt)
    (setq yoko yk)
    (cond
        ((not (zerop (computerNE tate yoko)))
         (loop
             (setq tate (- tate 1))
             (setq yoko (+ yoko 1))
             (if (eq (getBan tate yoko) (quote B)) (return T))
             (setBan tate yoko (quote B)) ) ) )
    (setq tate tt)
    (setq yoko yk)
    (cond
        ((not (zerop (computerNW tate yoko)))
         (loop
             (setq tate (- tate 1))
             (setq yoko (- yoko 1))
             (if (eq (getBan tate yoko) (quote B)) (return T))
             (setBan tate yoko (quote B)) ) ) )
    (setq tate tt)
    (setq yoko yk)
    (cond
        ((not (zerop (computerSE tate yoko)))
         (loop
             (setq tate (+ tate 1))
             (setq yoko (+ yoko 1))
             (if (eq (getBan tate yoko) (quote B)) (return T))
             (setBan tate yoko (quote B)) ) ) )
    (setq tate tt)
    (setq yoko yk)
    (cond
        ((not (zerop (computerSW tate yoko)))
         (loop
             (setq tate (+ tate 1))
             (setq yoko (- yoko 1))
             (if (eq (getBan tate yoko) (quote B)) (return T))
             (setBan tate yoko (quote B)) ) ) ) ) )

(defun YouGo (tate yoko)
  (let ((tt) (yk) )
    (setBan tate yoko (quote W))
    (setq tt tate)
    (setq yk yoko)
    (cond
        ((not (zerop (youNN tate yoko)))
         (loop
             (setq tate (- tate 1))
             (if (eq (getBan tate yoko) (quote W)) (return T))
             (setBan tate yoko (quote W)) ) ) )
    (setq tate tt)
    (setq yoko yk)
    (cond
        ((not (zerop (youSS tate yoko)))
         (loop
             (setq tate (+ tate 1))
             (if (eq (getBan tate yoko) (quote W)) (return T))
             (setBan tate yoko (quote W)) ) ) )
    (setq tate tt)
    (setq yoko yk)
    (cond
        ((not (zerop (youEE tate yoko)))
         (loop
             (setq yoko (+ yoko 1))
             (if (eq (getBan tate yoko) (quote W)) (return T))
             (setBan tate yoko (quote W)) ) ) )
    (setq tate tt)
    (setq yoko yk)
    (cond
        ((not (zerop (youWW tate yoko)))
         (loop
             (setq yoko (- yoko 1))
             (if (eq (getBan tate yoko) (quote W)) (return T))
             (setBan tate yoko (quote W)) ) ) )
    (setq tate tt)
    (setq yoko yk)
    (cond
        ((not (zerop (youNE tate yoko)))
         (loop
             (setq tate (- tate 1))
             (setq yoko (+ yoko 1))
             (if (eq (getBan tate yoko) (quote W)) (return T))
             (setBan tate yoko (quote W)) ) ) )
    (setq tate tt)
    (setq yoko yk)
    (cond
        ((not (zerop (youNW tate yoko)))
         (loop
             (setq tate (- tate 1))
             (setq yoko (- yoko 1))
             (if (eq (getBan tate yoko) (quote W)) (return T))
             (setBan tate yoko (quote W)) ) ) )
    (setq tate tt)
    (setq yoko yk)
    (cond
        ((not (zerop (youSE tate yoko)))
         (loop
             (setq tate (+ tate 1))
             (setq yoko (+ yoko 1))
             (if (eq (getBan tate yoko) (quote W)) (return T))
             (setBan tate yoko (quote W)) ) ) )
    (setq tate tt)
    (setq yoko yk)
    (cond
        ((not (zerop (youSW tate yoko)))
         (loop
             (setq tate (+ tate 1))
             (setq yoko (- yoko 1))
             (if (eq (getBan tate yoko) (quote W)) (return T))
             (setBan tate yoko (quote W)) ) ) ) ) )

(defun makeComputerKoho ()
  (let ((koho) (tate) (yoko) (n) (a) (b) )
    (setq koho NIL)
    (setq tate 1)
    (loop
        (if (eq tate 9) (return koho))
        (setq yoko 1)
        (loop
            (if (eq yoko 9) (return T))
            (setq n (getNumber tate yoko))
            (cond
                ((zerop n) NIL)
                (T
                  (setq a (cons tate (list yoko)))
                  (setq b (cons a (list n)))
                  (setq koho (append koho (list b))) ) )
            (setq yoko (+ yoko 1)) )
        (setq tate (+ tate 1)) ) ) )

(defun getNumber (tate yoko)
  (let ((n) )
    (cond
        ((not (eq (quote E) (getBan tate yoko))) 0)
        (T
          (setq n (computerNN tate yoko))
          (setq n (+ n (computerNE tate yoko)))
          (setq n (+ n (computerEE tate yoko)))
          (setq n (+ n (computerSE tate yoko)))
          (setq n (+ n (computerSS tate yoko)))
          (setq n (+ n (computerSW tate yoko)))
          (setq n (+ n (computerWW tate yoko)))
          (+ n (computerNW tate yoko)) ) ) ) )

(defun computerNN (tate yoko)
  (let ((n) )
    (setq tate (- tate 1))
    (cond
        ((zerop tate) 0)
        ((not (eq (quote W) (getBan tate yoko))) 0)
        (T
           (setq n 1)
           (loop
               (setq tate (- tate 1))
               (if (zerop tate) (return 0))
               (if (eq (quote E) (getBan tate yoko)) (return 0))
               (if (eq (quote B) (getBan tate yoko)) (return n))
               (setq n (+ n 1)) ) ) ) ) )

(defun computerSS (tate yoko)
  (let ((n) )
    (setq tate (+ tate 1))
    (cond
        ((eq tate 9) 0)
        ((not (eq (quote W) (getBan tate yoko))) 0)
        (T
           (setq n 1)
           (loop
               (setq tate (+ tate 1))
               (if (eq tate 9) (return 0))
               (if (eq (quote E) (getBan tate yoko)) (return 0))
               (if (eq (quote B) (getBan tate yoko)) (return n))
               (setq n (+ n 1)) ) ) ) ) )

(defun computerEE (tate yoko)
  (let ((n) )
    (setq yoko (+ yoko 1))
    (cond
        ((eq yoko 9) 0)
        ((not (eq (quote W) (getBan tate yoko))) 0)
        (T
           (setq n 1)
           (loop
               (setq yoko (+ yoko 1))
               (if (eq yoko 9) (return 0))
               (if (eq (quote E) (getBan tate yoko)) (return 0))
               (if (eq (quote B) (getBan tate yoko)) (return n))
               (setq n (+ n 1)) ) ) ) ) )

(defun computerWW (tate yoko)
  (let ((n) )
    (setq yoko (- yoko 1))
    (cond
        ((zerop yoko) 0)
        ((not (eq (quote W) (getBan tate yoko))) 0)
        (T
           (setq n 1)
           (loop
               (setq yoko (- yoko 1))
               (if (zerop yoko) (return 0))
               (if (eq (quote E) (getBan tate yoko)) (return 0))
               (if (eq (quote B) (getBan tate yoko)) (return n))
               (setq n (+ n 1)) ) ) ) ) )

(defun computerNW (tate yoko)
  (let ((n) )
    (setq yoko (- yoko 1))
    (setq tate (- tate 1))
    (cond
        ((zerop yoko) 0)
        ((zerop tate) 0)
        ((not (eq (quote W) (getBan tate yoko))) 0)
        (T
           (setq n 1)
           (loop
               (setq yoko (- yoko 1))
               (setq tate (- tate 1))
               (if (zerop yoko) (return 0))
               (if (zerop tate) (return 0))
               (if (eq (quote E) (getBan tate yoko)) (return 0))
               (if (eq (quote B) (getBan tate yoko)) (return n))
               (setq n (+ n 1)) ) ) ) ) )

(defun computerSW (tate yoko)
  (let ((n) )
    (setq yoko (- yoko 1))
    (setq tate (+ tate 1))
    (cond
        ((zerop yoko) 0)
        ((eq tate 9) 0)
        ((not (eq (quote W) (getBan tate yoko))) 0)
        (T
           (setq n 1)
           (loop
               (setq yoko (- yoko 1))
               (setq tate (+ tate 1))
               (if (zerop yoko) (return 0))
               (if (eq tate 9) (return 0))
               (if (eq (quote E) (getBan tate yoko)) (return 0))
               (if (eq (quote B) (getBan tate yoko)) (return n))
               (setq n (+ n 1)) ) ) ) ) )

(defun computerSE (tate yoko)
  (let ((n) )
    (setq yoko (+ yoko 1))
    (setq tate (+ tate 1))
    (cond
        ((eq yoko 9) 0)
        ((eq tate 9) 0)
        ((not (eq (quote W) (getBan tate yoko))) 0)
        (T
           (setq n 1)
           (loop
               (setq yoko (+ yoko 1))
               (setq tate (+ tate 1))
               (if (eq yoko 9) (return 0))
               (if (eq tate 9) (return 0))
               (if (eq (quote E) (getBan tate yoko)) (return 0))
               (if (eq (quote B) (getBan tate yoko)) (return n))
               (setq n (+ n 1)) ) ) ) ) )

(defun computerNE (tate yoko)
  (let ((n) )
    (setq yoko (+ yoko 1))
    (setq tate (- tate 1))
    (cond
        ((eq yoko 9) 0)
        ((zerop tate) 0)
        ((not (eq (quote W) (getBan tate yoko))) 0)
        (T
           (setq n 1)
           (loop
               (setq yoko (+ yoko 1))
               (setq tate (- tate 1))
               (if (eq yoko 9) (return 0))
               (if (zerop tate) (return 0))
               (if (eq (quote E) (getBan tate yoko)) (return 0))
               (if (eq (quote B) (getBan tate yoko)) (return n))
               (setq n (+ n 1)) ) ) ) ) )

(defun youNN (tate yoko)
  (let ((n) )
    (setq tate (- tate 1))
    (cond
        ((zerop tate) 0)
        ((not (eq (quote B) (getBan tate yoko))) 0)
        (T
           (setq n 1)
           (loop
               (setq tate (- tate 1))
               (if (zerop tate) (return 0))
               (if (eq (quote E) (getBan tate yoko)) (return 0))
               (if (eq (quote W) (getBan tate yoko)) (return n))
               (setq n (+ n 1)) ) ) ) ) )

(defun youSS (tate yoko)
  (let ((n) )
    (setq tate (+ tate 1))
    (cond
        ((eq tate 9) 0)
        ((not (eq (quote B) (getBan tate yoko))) 0)
        (T
           (setq n 1)
           (loop
               (setq tate (+ tate 1))
               (if (eq tate 9) (return 0))
               (if (eq (quote E) (getBan tate yoko)) (return 0))
               (if (eq (quote W) (getBan tate yoko)) (return n))
               (setq n (+ n 1)) ) ) ) ) )

(defun youEE (tate yoko)
  (let ((n) )
    (setq yoko (+ yoko 1))
    (cond
        ((eq yoko 9) 0)
        ((not (eq (quote B) (getBan tate yoko))) 0)
        (T
           (setq n 1)
           (loop
               (setq yoko (+ yoko 1))
               (if (eq yoko 9) (return 0))
               (if (eq (quote E) (getBan tate yoko)) (return 0))
               (if (eq (quote W) (getBan tate yoko)) (return n))
               (setq n (+ n 1)) ) ) ) ) )

(defun youWW (tate yoko)
  (let ((n) )
    (setq yoko (- yoko 1))
    (cond
        ((zerop yoko) 0)
        ((not (eq (quote B) (getBan tate yoko))) 0)
        (T
           (setq n 1)
           (loop
               (setq yoko (- yoko 1))
               (if (zerop yoko) (return 0))
               (if (eq (quote E) (getBan tate yoko)) (return 0))
               (if (eq (quote W) (getBan tate yoko)) (return n))
               (setq n (+ n 1)) ) ) ) ) )

(defun youNW (tate yoko)
  (let ((n) )
    (setq yoko (- yoko 1))
    (setq tate (- tate 1))
    (cond
        ((zerop yoko) 0)
        ((zerop tate) 0)
        ((not (eq (quote B) (getBan tate yoko))) 0)
        (T
           (setq n 1)
           (loop
               (setq yoko (- yoko 1))
               (setq tate (- tate 1))
               (if (zerop yoko) (return 0))
               (if (zerop tate) (return 0))
               (if (eq (quote E) (getBan tate yoko)) (return 0))
               (if (eq (quote W) (getBan tate yoko)) (return n))
               (setq n (+ n 1)) ) ) ) ) )

(defun youSW (tate yoko)
  (let ((n) )
    (setq yoko (- yoko 1))
    (setq tate (+ tate 1))
    (cond
        ((zerop yoko) 0)
        ((eq tate 9) 0)
        ((not (eq (quote B) (getBan tate yoko))) 0)
        (T
           (setq n 1)
           (loop
               (setq yoko (- yoko 1))
               (setq tate (+ tate 1))
               (if (zerop yoko) (return 0))
               (if (eq tate 9) (return 0))
               (if (eq (quote E) (getBan tate yoko)) (return 0))
               (if (eq (quote W) (getBan tate yoko)) (return n))
               (setq n (+ n 1)) ) ) ) ) )

(defun youSE (tate yoko)
  (let ((n) )
    (setq yoko (+ yoko 1))
    (setq tate (+ tate 1))
    (cond
        ((eq yoko 9) 0)
        ((eq tate 9) 0)
        ((not (eq (quote B) (getBan tate yoko))) 0)
        (T
           (setq n 1)
           (loop
               (setq yoko (+ yoko 1))
               (setq tate (+ tate 1))
               (if (eq yoko 9) (return 0))
               (if (eq tate 9) (return 0))
               (if (eq (quote E) (getBan tate yoko)) (return 0))
               (if (eq (quote W) (getBan tate yoko)) (return n))
               (setq n (+ n 1)) ) ) ) ) )

(defun youNE (tate yoko)
  (let ((n) )
    (setq yoko (+ yoko 1))
    (setq tate (- tate 1))
    (cond
        ((eq yoko 9) 0)
        ((zerop tate) 0)
        ((not (eq (quote B) (getBan tate yoko))) 0)
        (T
           (setq n 1)
           (loop
               (setq yoko (+ yoko 1))
               (setq tate (- tate 1))
               (if (eq yoko 9) (return 0))
               (if (zerop tate) (return 0))
               (if (eq (quote E) (getBan tate yoko)) (return 0))
               (if (eq (quote W) (getBan tate yoko)) (return n))
               (setq n (+ n 1)) ) ) ) ) )

(defun init-game ()
    (setq ban (quote (
                        (E E E E E E E E)
                        (E E E E E E E E)
                        (E E E E E E E E)
                        (E E E W B E E E)
                        (E E E B W E E E)
                        (E E E E E E E E)
                        (E E E E E E E E)
                        (E E E E E E E E) ) ) ) )

(defun display ()
  (let ((b) (gyou) (i) )
    (setq i 1)
;    (spaces 2)
    (princ "  ")
    (loop
        (if (eq i 9) (return T))
        (princ i)
;        (spaces 1)
	(princ " ")
        (setq i (+ i 1)) )
    (terpri)
    (setq b ban)
    (setq i 1)
    (loop
        (if (null b) (return T))
        (setq gyou (car b))
        (princ i)
        (setq i (+ i 1))
        (display2 gyou)
        (terpri)
        (setq b (cdr b)) ) ) )

(defun display2 (g)
    (loop
        (if (null g) (return T))
        (cond
            ((eq (quote E) (car g)) (princ (quote "・")))
            ((eq (quote W) (car g)) (princ (quote "● ")))
            ((eq (quote B) (car g)) (princ (quote "○ "))) )
        (setq g (cdr g)) ) )

(othello)
