; time.lsp

(load "others.lsp")

(defmacro time (b)
    `(let ((start (now)) (ret) (t1))
	(setq ret ,b)
	(setq t1 (now- (now) start))
	(princ (+ (* (car t1) 3600) (cdr t1))) (princ "秒") (terpri)
	ret ) )

(defun now- (t1 t2)
    (let ((a) (b))
	(setq a (- (car t1) (car t2)))
	(cond
	    ((>= (cdr t1) (cdr t2))
	     (setq b (- (cdr t1) (cdr t2))) )
	    (t
	     (setq a (1- a))
	     (setq b
		(- (+ (cdr t1) 3600)
		   (cdr t2) ) ) ) )
	(cons a b) ) )

(defun now+ (n1 n2)
    (let ((a) (d))
	(setq a (+ (car n1) (car n2)))
	(setq a (+ a (floor (/ (+ (cdr n1) (cdr n2)) 3600))))
	(setq d (mod (+ (cdr n1) (cdr n2)) 3600))
	(cons a d) ) )

(defun now> (n1 n2)
    (cond
	((> (car n1) (car n2)) t)
	((< (car n1) (car n2)) nil)
	((> (cdr n1) (cdr n2)) t)
	(t nil) ) )

(defun now= (n1 n2) (if (equal n1 n2) t nil))
